#include <windows.h>
#include <stdio.h>

#define TEST_IOCTL CTL_CODE(FILE_DEVICE_UNKNOWN, 0x801, METHOD_IN_DIRECT, FILE_ANY_ACCESS)

int main(int argc, char *argv[])
{
	HANDLE hFile = INVALID_HANDLE_VALUE;
	INT value;
	DWORD dwReturned;

	if(argc < 2){
		printf("Usage: %s <value>\n", argv[0]);
		return 0;
	}

	value = atoi(argv[1]);

	hFile = CreateFileW(L"\\\\.\\Que", GENERIC_WRITE, FILE_SHARE_WRITE, NULL, OPEN_EXISTING, NULL, NULL);

	if(hFile == INVALID_HANDLE_VALUE){
		printf("Error on CreateFile: %d\n", GetLastError());
		return 0;
	}

	if(DeviceIoControl(hFile, TEST_IOCTL, (LPVOID)&value, sizeof(INT), NULL, 0, &dwReturned, NULL) == FALSE){
		printf("Error on DeviceIoControl: %d\n", GetLastError());
	}

	if(!CloseHandle(hFile)){
		printf("Error on CloseHandle: %d\n", GetLastError());
	}

	return 0;
}